<?php

$max_bloecke = 5;
$end = false;
$bestresult_verteilung = array();
$bestresult_noten = array();
$bestresult_endnote = 6.1;
$bestresult_variationen = 1;

$purenotes = array('1.0','1.3','1.7','2.0','2.3','2.7','3.0','3.3','3.7','4.0','5.0');

$bool_zu = true;
$bool_ab = false;

$debug = false;

class Pruefung{
  var $id;
  var $name;
  var $note;
  var $sws;
  var $block;
  var $inBlock;

  function Pruefung($id, $name, $note, $sws){
    $this->id = $id;
    $this->name = $name;
    $this->note = $note;
    $this->sws = $sws;
    $this->block = 0;
    $this->inBlock = false;
  }

}

// Array initialisieren
$pruefungsliste = array();

// Array befüllen
$pruefungsliste[] = &new Pruefung(0, "Adele", 2.7, 4);
$pruefungsliste[] = &new Pruefung(1, "Signalverarbeitung", 3.0, 4);
$pruefungsliste[] = &new Pruefung(2, "Medizinelektronik", 2.0, 4);
$pruefungsliste[] = &new Pruefung(3, "Neuronale Netze", 1.3, 2);
$pruefungsliste[] = &new Pruefung(4, "Projekt Elektronik", 1.3, 4);
$pruefungsliste[] = &new Pruefung(5, "MC-Labor", 1.3, 4);
$pruefungsliste[] = &new Pruefung(6, "IntSch", 3.7, 3);
$pruefungsliste[] = &new Pruefung(7, "PuTHLB", 3.7, 3);
$pruefungsliste[] = &new Pruefung(8, "ECES", 2.3, 2);

function getTheSmallestUnarranged(){
global $pruefungsliste;
if ($debug){echo("getMin -> ");};

  for($i = 0; $i < sizeof($pruefungsliste); $i++){
    if ($pruefungsliste[$i]->inBlock == false){
      return $pruefungsliste[$i];
    }
  }
  return null;
}

function getTheBiggestArranged(){
global $pruefungsliste;

if ($debug){echo("getMax --> ");}
  for($i = sizeof($pruefungsliste)-1; $i >= 0; $i--){
    if ($pruefungsliste[$i]->inBlock == true){
      return $pruefungsliste[$i];
    }
  }
  return null;
}

function calcNote(){
  global $debug;
  
  global $pruefungsliste;
  global $max_bloecke;

  global $bestresult_verteilung;
  global $bestresult_noten;
  global $bestresult_endnote;
  global $bestresult_variationen;
  global $purenotes;

  if ($debug){echo("calculating()<br />");}
  
  $result_verteilung = array();
  $result_noten = array();
  $result_endnote;

  // Aufteilen nach Blöcken
  for($x = 1; $x <= $max_bloecke; $x++){
    $temparray = array();
    for($i = 0; $i < sizeof($pruefungsliste); $i++){
      if ($pruefungsliste[$i]->block == $x){
		$temparray[] = $pruefungsliste[$i];
      }
    }
    if (sizeof($temparray) > 0){
      $result_verteilung[$x] = $temparray;
    }
    unset($temparray);
  }
  
  if (sizeof($result_verteilung)<$max_bloecke){
	if ($debug){echo("not enough used bloecke<br />");}
	return;
  }
  
  // Ausrechnen nach Blöcken
  for($x = 1; $x <= $max_bloecke; $x++){
    $temparray = array();
    $summe = 0;
    $sws = 0;
    for($i = 0; $i < sizeof($result_verteilung[$x]); $i++){
      $summe = $summe + ($result_verteilung[$x][$i]->note * $result_verteilung[$x][$i]->sws);
      $sws = $sws + $result_verteilung[$x][$i]->sws;
    }
    if ($sws != 0){
      $blockergebnis = $summe / $sws;
      if ($debug){echo("blockergebnis von Block".$x.": ".$blockergebnis."<br />");}
      $temparray[0] = $blockergebnis;
      $temparray[1] = $sws;
      $result_noten[$x] = $temparray;
    }
    $summe = 0;
    $sws = 0;
    unset($temparray);
  }

  // Runden

  foreach ($result_noten as $index => $notenarray){
		$abstand = 9000;
		$note = 6.0;
		for($i = 0; $i < sizeof($purenotes); $i++){
			$aktuellerabstand = abs($notenarray[0] - $purenotes[$i]);
			if ($aktuellerabstand < $abstand){
				$abstand = $aktuellerabstand;
				$note = $purenotes[$i];
			}
		}
		if ($debug){echo("Block ".$index." Runden: von ".$notenarray[0]." um ".$abstand." zu ".$note."<br />");}
		$result_noten[$index][0] = $note;
	}

  // Gesamtnote
  $gesamt_sws = 0;
  $gesamt_note = 0;
  foreach ($result_noten as $value){
      $gesamt_sws = $gesamt_sws + $value[1];
      $gesamt_note = $gesamt_note + ($value[0] * $value[1]);
  }  
  $result_endnote = $gesamt_note / $gesamt_sws;
  if ($debug){echo("Endnote : ".$result_endnote." <br />");}

  // Speichern falls besser
  if ($result_endnote == $bestresult_endnote){
	$bestresult_variationen++;
  }
  
  if ($result_endnote < $bestresult_endnote){
    $bestresult_endnote = $result_endnote;
    $bestresult_verteilung = $result_verteilung;
	$bestresult_variationen = 1;
	/*
	echo("Endnote : ".$bestresult_endnote." <br />");	
	print_r("<pre>");
	print_r($bestresult_verteilung);
	print_r("</pre>");	
	*/
  }

}

function unarrange(){
  global $debug;
  global $max_bloecke;
  global $end;
  global $bool_zu;
  global $bool_ab;
  
  $bool_zu = false;
  $bool_ab = false;
  
  if ($debug){echo("unarrangeBloecke() <br />");}
  $object = getTheBiggestArranged();
  if ($object == null){
    if ($debug){echo("null <br />");}
    //ENDE
    $end = true;
    if ($debug){echo("end of function <br />");}
  }
  else{
    if ($debug){echo($object->name." <br />");}
	$object->inBlock = false;
    if ($object->block == $max_bloecke){
      if ($debug){echo($object->name." reached maxBloecke <br />");}
      $object->block = 0;
      $bool_ab = true;
    }
	$bool_zu = true;
  }
}

function arrangeBloecke(){
  global $end;
  global $bool_zu;
  global $bool_ab;
  global $debug;
  
  $bool_zu = false;
  $bool_ab = false;
  
  if ($end){
    return;
  }

  if ($debug){echo("arrangeBloecke()<br />");}
  $object = getTheSmallestUnarranged();

  if ($object == null){
    if ($debug){echo("null <br />");}
    calcNote();
    $bool_ab = true;
  }
  else{
    if ($debug){echo($object->name. "<br />");}
    if ($debug){echo("new Block of ".$object->name." is ".($object->block + 1)."<br />");}
    $object->block  = ($object->block + 1); 
    $object->inBlock = true;
    $bool_zu = true;
  }
}


// Array-Inhalt testen
/*
print_r("<pre>");
print_r($pruefungsliste);
print_r("</pre>");
*/

// Optimierung ausführen

while(!$end){
	while($bool_zu){
		arrangeBloecke();
	}
	while($bool_ab){
		unarrange();
	}
}

/*
while(!$end){
	while($bool_zu){arrangeBloecke();}
	while($bool_ab){unarrange();}
}
*/

?>


<html>
<head>
<title>Studien-Schwerpunkt-Pr&uuml;fungs-Optimierung</title>
</head>

<body>
<h1>Studien-Schwerpunkt-Pr&uuml;fungs-Optimierung</h1>


<?php

echo ("! ".$bestresult_endnote." ! (".$bestresult_variationen.")");
foreach ($bestresult_verteilung as $value){
  if(sizeof($value) > 0){
    echo ("<br />");
    echo ("------------------------------ <br />");
    foreach ($value as $object){
      echo ($object->name."<br />");
    }
    echo ("------------------------------<br />");
    echo ("<br />");
  }
}
?>


</body>
</html>